//
// PIMS ( http://forge.scilab.org/index.php/p/pims ) - This file is part of PIMS
// Copyright (C) 2013 - Scilab Enterprises - Simon MARCHETTO
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function [pythonPath, numPyPath] = checkPythonOnWindows()
    //find registry information about python
    keyPath = ["SOFTWARE\Python\PythonCore\2.7\InstallPath"]
    err = execstr("pythonPath = winqueryreg(""HKEY_LOCAL_MACHINE"", keyPath, """");", "errcatch");
    if err then
        err = execstr("pythonPath = winqueryreg(""HKEY_CURRENT_USER"", keyPath, """");", "errcatch");
        if err then
            error("You must install python 2.7. See http://www.python.org/");
            return;
        end;
    end

    //check numpy is installed
    numPyPath = pythonPath + "Lib\site-packages\numpy\core\include";
    if isdir(numPyPath) == %f then
        error("You must install numPy for Python 2.7. See http://numpy.scipy.org/");
    end
endfunction
