//
// PIMS ( http://forge.scilab.org/index.php/p/pims ) - This file is part of PIMS
// Copyright (C) 2013 - Scilab Enterprises - Simon MARCHETTO
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function [CFLAGS, LDFLAGS] = getBuildFlags(pimsSrcPath)
    CFLAGS = "-I" + fullpath(pimsSrcPath);
    CFLAGS = CFLAGS + " -I" + fullpath(SCI + "/modules/external_objects/includes");

    LDFLAGS = "";
endfunction

function [CFLAGS, LDFLAGS] = getBuildFlagsForWindows(pythonPath, numPyPath)
    CFLAGS = "-D_MSC_VER";

    if win64() then
        CFLAGS = CFLAGS + " -DWIN64";
        LDFLAGS = "/MACHINE:X64";
    else
        CFLAGS = CFLAGS + " -DWIN32";
        LDFLAGS = "/MACHINE:X86";
    end

    CFLAGS = CFLAGS + " -I"  + fullfile(pythonPath, "include");
    CFLAGS = CFLAGS + " -I" + numPyPath;

    LDFLAGS = pythonPath + "libs\python27.lib";
    LDFLAGS = LDFLAGS + " " + SCI + "\bin\external_objects.lib";
endfunction

function [CFLAGS, LDFLAGS] = getBuildFlagsForLinuxMac(currentPath)
    CFLAGS = "-I"  + fullpath("/usr/include/python2.7");

    LDFLAGS = "-L" + fullpath(currentPath + "../../sci_gateway/cpp");
    LDFLAGS = LDFLAGS + " -L" + fullpath(SCI + "/modules/external_objects/.libs");
    LDFLAGS = LDFLAGS + " -lpython2.7";
endfunction