//
// PIMS ( http://forge.scilab.org/index.php/p/pims ) - This file is part of PIMS
// Copyright (C) 2012 - Scilab Enterprises - Calixte DENIZET
// Copyright (C) 2012 - Scilab Enterprises - Antoine ELIAS
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function builder_gw_cpp()
    currentPath = get_absolute_file_path("builder_gateway_cpp.sce");
    oldPath = pwd();
    cd(currentPath);

    exec("../../macros/checkPython.sci");
    exec("../../macros/getBuildFlags.sci");

    gw_table = [
        "pyImport", "sci_pyImport";
        "pyAutounwrap", "sci_pyAutounwrap";
        "pyGetMethods", "sci_pyGetMethods";
        "pyGetFields", "sci_pyGetFields";
        "pyDeff", "sci_pyDeff";
        "pyRepr", "sci_pyRepr";
        "pyExists", "sci_pyExists";
        "pyGetField", "sci_pyGetField";
        "pyRemove", "sci_pyRemove";
        "pyUnwrap", "sci_pyUnwrap";
        "pyWrap", "sci_pyWrap";
        "pyAllowModuleReloading", "sci_pyAllowModuleReloading";
        "pyGetInfos", "sci_pyGetInfos";
        "pyGetPath", "sci_pyGetPath";
        "pyAddToPath", "sci_pyAddToPath";
        "pyTuple", "sci_pyTuple";
        "pyDict", "sci_pyDict";
        "pyList", "sci_pyList";
        "pySet", "sci_pySet";
        "pyGetName", "sci_pyGetName";
        "pyEvalStr", "sci_pyEvalStr";
        "pyWrapAsRef", "sci_pyWrapAsRef";
        "pyUnwrapRem", "sci_pyUnwrapRem";
        "pyByCopy", "sci_pyByCopy";
        "pyUseNumpy", "sci_pyUseNumpy";
        "pyUseScilabIndex", "sci_pyUseScilabIndex";
        "pyGetEnvId", "sci_pyGetEnvId";
        "pyKill", "sci_pyKill";
        "pyTrace", "sci_pyTrace";
        "pyAddVar", "sci_pyAddVar";
        "pyGetVar", "sci_pyGetVar";
        "pyShowPrivate", "sci_pyShowPrivate";
        "pyAttachModule", "sci_pyAttachModule";
        "pyGetAttr", "sci_pyGetAttr";
        "pyBuiltin", "sci_pyBuiltin";
        "pyMain", "sci_pyMain";
        "pyInvoke", "sci_pyInvoke";
        "pyNpWrap", "sci_pyNpWrap"];

    [CFLAGS, LDFLAGS] = getBuildFlags(currentPath + "../../src/cpp/");
    CFLAGS = CFLAGS + " -I" + fullpath(currentPath);

    if getos() == "Windows" then
        gw_src_cpp = [ls("sci_*.cpp")];

        [pythonPath, numPyPath] = checkPythonOnWindows();

        [CFLAGS_OS, LDFLAGS_OS] = getBuildFlagsForWindows(pythonPath, numPyPath);
        LDFLAGS_OS = LDFLAGS_OS + " " + currentPath + "../../src/cpp/libpims_cpp.lib";
    else
        gw_src_cpp = [ls(currentPath + "/sci_*.cpp")];

        [CFLAGS_OS, LDFLAGS_OS] = getBuildFlagsForLinuxMac();
    end

    CFLAGS = CFLAGS + " " + CFLAGS_OS;
    LDFLAGS = LDFLAGS + " " + LDFLAGS_OS;

    WITHOUT_AUTO_PUTLHSVAR = %t;

    tbx_build_gateway("gw_pims_c", gw_table, gw_src_cpp, currentPath, "", LDFLAGS, CFLAGS);
    cd(oldPath);
endfunction

builder_gw_cpp();
clear builder_gw_cpp;
clear checkPythonOnWindows;
clear getBuildFlags;
clear getBuildFlagsForWindows;
clear getBuildFlagsForLinuxMac;
