//
// PIMS ( http://forge.scilab.org/index.php/p/pims ) - This file is part of PIMS
// Copyright (C) 2012 - Scilab Enterprises - Calixte DENIZET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//

function build_cpp()
    oldPath = pwd();
    currentPath = get_absolute_file_path("builder_cpp.sce");
    cd(currentPath);

    exec("../../macros/checkPython.sci");
    exec("../../macros/getBuildFlags.sci");

    [CFLAGS, LDFLAGS] = getBuildFlags(currentPath);

    if getos() == "Windows" then
        src_cpp = ls("*.cpp");

        [pythonPath, numPyPath] = checkPythonOnWindows();

        [CFLAGS_OS, LDFLAGS_OS] = getBuildFlagsForWindows(pythonPath, numPyPath);
        CFLAGS_OS = CFLAGS_OS + " -DPIMS_EXPORTS";
    else
        src_cpp = ls(currentPath + "/*.cpp");

        [CFLAGS_OS, LDFLAGS_OS] = getBuildFlagsForLinuxMac();
    end

    CFLAGS = CFLAGS + " " + CFLAGS_OS;
    LDFLAGS = LDFLAGS + " " + LDFLAGS_OS;

    tbx_build_src('pims_cpp', src_cpp, 'cpp', currentPath, '', LDFLAGS, CFLAGS);
    cd(oldPath);
endfunction

build_cpp();
clear build_cpp;
clear checkPythonOnWindows;
clear getBuildFlags;
clear getBuildFlagsForWindows;
clear getBuildFlagsForLinuxMac;
